Avoid the deprecated GetVersionEx API
[oota-llvm.git] / lib / Support / Windows / WindowsSupport.h
index cb091f1..60490f2 100644 (file)
 #include <vector>
 
 /// Determines if the program is running on Windows 8 or newer. This
-/// reimplements the helpers in the Windows 8.1 SDK, which are intended to
-/// supercede raw calls to GetVersionEx, because old Windows SDKs, Cygwin, and
-/// MinGW don't have VersionSupport.h yet.
-inline bool IsWindows8OrGreater() {
-  OSVERSIONINFO osvi = {};
+/// reimplements one of the helpers in the Windows 8.1 SDK, which are intended
+/// to supercede raw calls to GetVersionEx. Old SDKs, Cygwin, and MinGW don't
+/// yet have VersionHelpers.h, so we have our own helper.
+inline bool RunningWindows8OrGreater() {
+  // Windows 8 is version 6.2, service pack 0.
+  OSVERSIONINFOEXW osvi = {};
   osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
-  if (!::GetVersionEx(&osvi))
-    return false;
-  return (osvi.dwMajorVersion > 6 ||
-          (osvi.dwMajorVersion == 6 && osvi.dwMinorVersion >= 2));
+  osvi.dwMajorVersion = 6;
+  osvi.dwMinorVersion = 2;
+  osvi.wServicePackMajor = 0;
+
+  DWORDLONG Mask = 0;
+  Mask = VerSetConditionMask(Mask, VER_MAJORVERSION, VER_GREATER_EQUAL);
+  Mask = VerSetConditionMask(Mask, VER_MINORVERSION, VER_GREATER_EQUAL);
+  Mask = VerSetConditionMask(Mask, VER_SERVICEPACKMAJOR, VER_GREATER_EQUAL);
+
+  return VerifyVersionInfoW(&osvi, VER_MAJORVERSION | VER_MINORVERSION |
+                                       VER_SERVICEPACKMAJOR,
+                            Mask) != FALSE;
 }
 
 inline bool MakeErrMsg(std::string* ErrMsg, const std::string& prefix) {